SCORE_RASTER_POS = 1
GAME_RASTER_POS  = 85;82 - 1
  
!zone InitIRQ
InitIRQ
          sei
          lda #<Irq
          ldx #>Irq
          sta $314
          stx $315
          
          lda #$1b
          ldx #$00
          ldy #$7f
          sta VIC.CONTROL_1
          stx VIC.RASTER_POS
          sty CIA1.IRQ_CONTROL
          
          lda #$01
          sta VIC.IRQ_MASK
          sta VIC.IRQ_REQUEST; ACK any raster IRQs

          cli
          rts


!zone Irq
Irq
          lda #$01
          sta VIC.IRQ_REQUEST ; ACK any raster IRQs

          lda CIA1.DATA_PORT_A
          sta JOY_VALUE
          
          jsr SFXUpdate
          
          ;jsr MUSIC_PLAYER + 3
          
          ;lda IN_GAME_ACTIVE
;          beq +
;          
;          ;install next state
;          lda #<IrqSetScoreDisplay
;          sta $0314
;          lda #>IrqSetScoreDisplay
;          sta $0315
;          
;          
;          ;nr of rasterline we want our irq occur at
;          lda #SCORE_RASTER_POS
;          sta VIC.RASTER_POS
;          
;+          
          jmp $ea31

          

!zone IrqSetScoreDisplay
IrqSetScoreDisplay
          ;acknowledge VIC irq
          lda VIC.IRQ_REQUEST
          sta VIC.IRQ_REQUEST

          ;install next state
          lda #<IrqSetGameDisplay
          sta $0314
          lda #>IrqSetGameDisplay
          sta $0315
          
          
          ;nr of rasterline we want our irq occur at
          lda #GAME_RASTER_POS
          sta VIC.RASTER_POS
          
          ;set charset
          lda #$1a
          sta VIC.MEMORY_CONTROL
          ;lda TOP_CHARSET_MULTICOLOR_1
          ;sta VIC.CHARSET_MULTICOLOR_1
          ;lda TOP_CHARSET_MULTICOLOR_2
          ;sta VIC.CHARSET_MULTICOLOR_2
          
          lda JOYSTICK_PORT_II
          sta JOY_VALUE
          
          jmp IRQ_RETURN_KERNAL_KEYBOARD
          
          
          
!zone IrqSetGameDisplay
IrqSetGameDisplay
          ldx #$1e

          lda CUR_GAME_RASTER_POS
-          
          cmp VIC.RASTER_POS
          bne -
          
          ;set charset
          stx VIC.MEMORY_CONTROL
          ;lda TOP_CHARSET_MULTICOLOR_1
          ;sta VIC.CHARSET_MULTICOLOR_1
          ;lda TOP_CHARSET_MULTICOLOR_2
          ;sta VIC.CHARSET_MULTICOLOR_2
          
          ;acknowledge VIC irq
          lda VIC.IRQ_REQUEST
          sta VIC.IRQ_REQUEST

          ;install next state
          lda #<IrqSetScoreDisplay
          sta $0314
          lda #>IrqSetScoreDisplay
          sta $0315
          
          
          ;nr of rasterline we want our irq occur at
          lda #SCORE_RASTER_POS
          sta VIC.RASTER_POS          
          jmp IRQ_RETURN_KERNAL
          
          
                    
          
IN_GAME_ACTIVE
          !byte 0
          
CUR_GAME_RASTER_POS = $02
          ;!byte 0